//
//  ViewController.m
//  GunDongTableView
//
//  Created by SunLi on 16/7/2.
//  Copyright © 2016年 lb. All rights reserved.
//

#import "ViewController.h"
#import "ToViewTest.h"

#define SCREENWIDTH ([UIScreen mainScreen].bounds.size.width)
#define SCREENHEIGHT ([UIScreen mainScreen].bounds.size.height)

@interface ViewController ()<UITableViewDelegate, UITableViewDataSource>
{
    NSUInteger clickCount;
}
@property(nonatomic, strong) UITableView *tableView;
@property(nonatomic, strong) ToViewTest *testView;
@property(nonatomic, strong) NSMutableArray *dataArray;
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.view.backgroundColor = [UIColor whiteColor];
    [self createUI];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)createUI{
    _dataArray = [[NSMutableArray alloc]init];
    for (int i = 0; i <300; i++) {
        [_dataArray addObject:[NSString stringWithFormat:@"测试:%d", i]];
    }
    [self initTableView];
    
    _testView= [[ToViewTest alloc]initWithFrame:CGRectMake(SCREENWIDTH-60, SCREENHEIGHT-60, 48, 48)];
    UITapGestureRecognizer *gesture = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(returnTop)];
    [_testView addGestureRecognizer:gesture];
    ///_testView.currValue = @"156";
    //_testView.totalValue = @"544";
    _testView.isRolling = YES;
    _testView.alpha = 0.0f;
    _testView.hidden = YES;
    
    clickCount = 156;
    UIButton *btn =[[UIButton alloc]initWithFrame:CGRectMake(10, 68, 68, 68)];
    [btn setTitle:@"刷新" forState:UIControlStateNormal];
    [btn setTitleColor:[UIColor greenColor] forState:UIControlStateNormal];
    [btn addTarget:self action:@selector(btnClick:) forControlEvents:UIControlEventTouchUpInside];
    //[self.view addSubview:btn];
}

- (void)viewWillAppear:(BOOL)animated{
    
    [self.view addSubview:_testView];
    //[self.view addSubview:_testView];
}


- (void)returnTop{
    //停止
    if (!_testView.isRolling){
        //[self.tableView scrollsToTop];
        //滚动到顶部
        [self.tableView setContentOffset:CGPointMake(0, 0) animated:YES];
    }
    
}


-(void)btnClick:(UIButton *)btn{
    clickCount +=1;
    _testView.currValue = [NSString stringWithFormat:@"%zd",clickCount];
    [_testView setNeedsDisplay];
}

//初始化tableView
-(void)initTableView{
    
    _tableView=[[UITableView alloc] initWithFrame:CGRectMake(0, 0,SCREENWIDTH, SCREENHEIGHT) style:UITableViewStylePlain];
    // 设置tableView的背景颜色
    _tableView.backgroundView = nil;
    [_tableView registerClass:[UITableViewCell class] forCellReuseIdentifier:@"cell"];
    _tableView.backgroundColor =  [UIColor colorWithRed:244/255.0f green:243/255.0f blue:241/255.0f alpha:1.0f];
    _tableView.delegate=self;
    _tableView.dataSource=self;
    [self.view addSubview:self.tableView];
    [self.tableView setTableFooterView:[[UIView alloc] initWithFrame:CGRectZero]];
}
#pragma mark UITableView datasource delegate

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return self.dataArray.count;
}

//初始化相关信息
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    UITableViewCell *cell=[tableView dequeueReusableCellWithIdentifier:@"cell" forIndexPath:indexPath];
    
    if (cell==nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:@"cell"];
    }
    
    cell.textLabel.text = [self.dataArray objectAtIndex:indexPath.row];
    return cell;
}

/**
 * 开始滚动处理
 */
- (void)scrollViewDidScroll:(UIScrollView *)scrollView{
    
    CGFloat offHeight =  self.tableView.contentOffset.y;
    CGFloat contentSizeHeight = self.tableView.contentSize.height-SCREENHEIGHT;
    if (offHeight >= SCREENHEIGHT){  // 超过当前屏幕高度时候开始开始显示滚动
        _testView.currValue = [NSString stringWithFormat:@"%ld", (long)offHeight];
        _testView.totalValue = [NSString stringWithFormat:@"%ld", (long)contentSizeHeight];
        _testView.isRolling = YES;
        if (_testView.isHidden){
            [UIView animateWithDuration:1.0f animations:^{
                _testView.alpha = 1.0f;
            } completion:^(BOOL finished) {
                [_testView setHidden:NO];
            }];
        }
        [_testView setNeedsDisplay];
    }else{
        if (!_testView.isHidden){
            [UIView animateWithDuration:1.0f animations:^{
                _testView.alpha = 0.0f;
                _testView.isRolling = YES;
                _testView.currValue = [NSString stringWithFormat:@"%ld", (long)offHeight];
                _testView.totalValue = [NSString stringWithFormat:@"%ld", (long)contentSizeHeight];
            } completion:^(BOOL finished) {
                [_testView setHidden:YES];
            }];
        }
    }
}

//结束加载
- (void)scrollViewDidEndDecelerating:(UIScrollView *)scrollView{
    CGFloat offHeight =  self.tableView.contentOffset.y;
    //实际高度
    CGFloat contentSizeHeight = self.tableView.contentSize.height-SCREENHEIGHT;
    if (!_testView.isHidden && offHeight >= SCREENHEIGHT){
        [UIView animateWithDuration:1.0f animations:^{
            //[UIView setAnimationCurve:UIViewAnimationCurveEaseIn];
            _testView.isRolling = NO;
            _testView.currValue = [NSString stringWithFormat:@"%ld", (long)offHeight];
            _testView.totalValue = [NSString stringWithFormat:@"%ld", (long)contentSizeHeight];
            _testView.alpha = 0.3;
            
        } completion:^(BOOL finished) {
            [_testView setHidden:NO];
            [_testView setNeedsDisplay];
            [UIView animateWithDuration:1.0f animations:^{
                //[UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
                _testView.alpha =1.0;
            } completion:^(BOOL finished) {
            }];
        }];
    }
}

#pragma mark - UITableViewDelegate
/**
 *  点击某一行cell
 */
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    
}

- (CGFloat) tableView:(UITableView *)tableView heightForRowAtIndexPath :(NSIndexPath *)indexPath {
    return 50;
}

@end
